VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "howto_search_multiple_patterns"
   ClientHeight    =   3090
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   6240
   LinkTopic       =   "Form1"
   ScaleHeight     =   3090
   ScaleWidth      =   6240
   StartUpPosition =   3  'Windows Default
   Begin VB.ListBox lstFiles 
      Height          =   1425
      Left            =   120
      TabIndex        =   5
      Top             =   1440
      Width           =   6015
   End
   Begin VB.CommandButton cmdGo 
      Caption         =   "Go"
      Default         =   -1  'True
      Height          =   495
      Left            =   2640
      TabIndex        =   4
      Top             =   840
      Width           =   1215
   End
   Begin VB.TextBox txtDirectory 
      Height          =   285
      Left            =   960
      TabIndex        =   1
      Top             =   120
      Width           =   5175
   End
   Begin VB.TextBox txtPatterns 
      Height          =   285
      Left            =   960
      TabIndex        =   0
      Text            =   "*.frm;*.txt"
      Top             =   480
      Width           =   5175
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Directory:"
      Height          =   195
      Index           =   0
      Left            =   120
      TabIndex        =   3
      Top             =   120
      Width           =   675
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Patterns:"
      Height          =   195
      Index           =   1
      Left            =   120
      TabIndex        =   2
      Top             =   480
      Width           =   630
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' Initialize the directory.
Private Sub Form_Load()
    txtDirectory.Text = App.Path
End Sub

' Make the controls as big as possible.
Private Sub Form_Resize()
Dim wid As Single
Dim hgt As Single

    wid = ScaleWidth - txtDirectory.Left - 120
    If wid < 120 Then wid = 120
    txtDirectory.Width = wid
    txtPatterns.Width = wid

    wid = ScaleWidth - 2 * 120
    If wid < 120 Then wid = 120
    hgt = ScaleHeight - lstFiles.Top - 120
    If hgt < 120 Then hgt = 120
    lstFiles.Width = wid
    lstFiles.Height = hgt

    cmdGo.Left = (ScaleWidth - cmdGo.Width) / 2
End Sub

' Search for files.
Private Sub cmdGo_Click()
Dim dirname As String
Dim files As Collection
Dim filename As Variant

    lstFiles.Clear
    dirname = txtDirectory.Text
    If Right$(dirname, 1) <> "\" Then dirname = dirname & "\"
    Set files = FindFiles(dirname, txtPatterns.Text)
    For Each filename In files
        lstFiles.AddItem filename
    Next filename
End Sub

' Return a list of files that match the patterns.
Private Function FindFiles(ByVal dirname As String, ByVal patterns As String) As Collection
Dim pattern_array() As String
Dim pattern As Variant
Dim files As Collection
Dim filename As String

    ' Separate the patterns.
    pattern_array = Split(patterns, ";")

    Set files = New Collection
    ' Loop through the files in the directory.
    filename = Dir$(dirname)
    Do While Len(filename) > 0
        ' See if the name matches any pattern.
        For Each pattern In pattern_array
            If LCase$(filename) Like LCase$(pattern) Then
                files.Add filename
                Exit For
            End If
        Next pattern

        filename = Dir$()
    Loop

    Set FindFiles = files
End Function

